"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var dashjs_1 = __importDefault(require("dashjs"));
var DASHReact = /** @class */ (function (_super) {
    __extends(DASHReact, _super);
    function DASHReact(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            player: null
        };
        return _this;
    }
    DASHReact.prototype.componentDidMount = function () {
        var _a;
        this.initializeDash(this.props.url, (_a = this.props.options) !== null && _a !== void 0 ? _a : {}, this.props.autoPlay);
    };
    DASHReact.prototype.componentWillUnmount = function () {
        // this.state.player.destroy(); 
        this.setState({ player: null });
    };
    DASHReact.prototype.initializeDash = function (url, options, autoPlay) {
        if (autoPlay === void 0) { autoPlay = false; }
        var player = dashjs_1.default.MediaPlayer().create();
        if (options)
            player.updateSettings(options);
        player.initialize(document.querySelector("#dash-react"), 
        // needs regex to select for anything beginning with dash-react 
        url, autoPlay);
        this.setState({ player: player });
    };
    DASHReact.prototype.render = function () {
        return (react_1.default.createElement("video", { "data-testid": "dash-react", id: "dash-react-" + (this.props.id ? +this.props.id : ''), className: this.props.className, controls: this.props.controls, preload: 'auto' }));
    };
    return DASHReact;
}(react_1.default.Component));
exports.default = DASHReact;
